/*-
 * Copyright (C)2017 @BABOLO http://www.babolo.ru/
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef lint
static const char copyright[] = "\
@(#)Copyright (C)2017 @BABOLO http://www.babolo.ru/\n\
@(#)All rights reserved.\n";
static const char rcsid[] = "$Id: func.c,v 1.7 2018/03/10 20:02:05 babolo Exp $";
#endif /* not lint */

#define BLIN_COMPAT  3
#define Bpars_COMPAT 3
#define MIFE_COMPAT  4

#include <sys/types.h>
#include <sys/event.h>
#include <sys/time.h>
#include <stdio.h>
#include <babolo/BLINflag.h>
#include <babolo/parser.h>
#include <multilar.h>
#include <mife.h>
#include "pgoblin.h"
#include "pgob.h"

int
/************************************************************************
 ************************************************************************
 **      cmd   rn.     **
 **    cmd  rn  ,   < 0 **
 **                                                                    **/
pgoblin_breg(pgoblin_command cmd, pgoblin_nr rn) {                    /**
 **                                                                    **
 ************************************************************************
 ************************************************************************/
    int j;

    j = -1;
    if  (pgoblin.a[cmd].flags & pgoblin.p[rn].sym) {
        /*  a[cmd].flags    [rn] */
        j = (pgoblin.p[rn].bin < 0)
            /*      */
          ? (pgoblin.a[cmd].flags >> ~pgoblin.p[rn].bin) & pgoblin.p[rn].mask
            /*      */
          : pgoblin.p[rn].bin
        ;
        if  (!(pgoblin.a[cmd].ch[j] & pgoblin.p[rn].val) && !!pgoblin.a[cmd].ch[j]) {
            /*                            *
             *     ,  -     . *
             *    0 j ,   j  ,      *
             *        j                    *
             */
            j = -2;
    }   }
    return(j);
}

int
pgoblin_cmdexe(int cmd, pgoblin_exenv *exenv, pgoblin_nr *rn) {
#   define blin_internal_flags (exenv->options->flags & BLIN_MASK)
    int ex, i, b;

    ifBLIN_QX3( "+%s %c%c%c%c%c%c %08X"
              , pgoblin.a[cmd].str
              , pgoblin_regn[rn[0]]
              , pgoblin_regn[rn[1]]
              , pgoblin_regn[rn[2]]
              , pgoblin_regn[rn[3]]
              , pgoblin_regn[rn[4]]
              , pgoblin_regn[rn[5]]
              , pgoblin.a[cmd].flags
              );
    for (i = 0; i < pgoblin.symparam; i++) if (0 > (b = pgoblin_breg(cmd, i))) {
        switch(i) {
        case PGO_CSTY:
            break;
        case PGO_CJOB:
            break;
        case PGO_CCON:
            break;
        default:
            break;
    }   }
    ex = (*(pgoblin.a[cmd].car))(exenv, rn);
    ifBLIN_QX3( "- %d", ex);
    return(ex);
#   undef blin_internal_flags
}

void *
pgoblin_getr(pgoblin_main *options, pgoblin_nr rn, int reg) {
#   define blin_internal_flags (options->flags & BLIN_MASK)
    switch(reg) {
    case PGO_CSTY: return(&(options->style[rn]));
    case PGO_CJOB: return(&(options->job[rn]));
    case PGO_CCON: return(&(options->conn[rn]));
    default:       return(&(options->io[rn]));
#   undef blin_internal_flags
}   }
